Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4092)
@@ -37,5 +37,5 @@
 using System.Transactions;
 using HeuristicLab.Hive.Server.LINQDataAccess;
-using IsolationLevel=System.Transactions.IsolationLevel;
+using IsolationLevel = System.Transactions.IsolationLevel;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -59,10 +59,9 @@
 
 
-    private void checkForDeadJobs() {
+    private void CheckForDeadJobs() {
       Logger.Info("Searching for dead Jobs");
-      using (
-        TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
-                                                      new TransactionOptions
-                                                      {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})) {
+
+      // [chn] why is transaction management done here?
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
         List<JobDto> allJobs = new List<JobDto>(DaoLocator.JobDao.FindAll());
         foreach (JobDto curJob in allJobs) {
@@ -73,10 +72,10 @@
         scope.Complete();
       }
-      DaoLocator.DestroyContext();
+      // DaoLocator.DestroyContext();
     }
 
     private void lifecycleManager_OnStartup(object sender, EventArgs e) {
       Logger.Info("Startup Event Fired, Checking DB for consistency");
-      checkForDeadJobs();
+      CheckForDeadJobs();
       Logger.Info("Startup Event Done");
     }
@@ -84,5 +83,5 @@
     private void lifecycleManager_OnShutdown(object sender, EventArgs e) {
       Logger.Info("Startup Event Fired, Checking DB for consistency");
-      checkForDeadJobs();
+      CheckForDeadJobs();
       Logger.Info("Startup Event Done");
     }
@@ -129,6 +128,5 @@
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_GET_JOB_BY_ID;
-      }
-      else {
+      } else {
         response.Success = false;
         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
@@ -146,6 +144,5 @@
 
         job.Obj.Client = DaoLocator.ClientDao.GetClientForJob(jobId);
-      }
-      else {
+      } else {
         job.Success = false;
         job.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
@@ -196,6 +193,5 @@
         response.Obj = job.JobInfo;
         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_ADDED;
-      }
-      else {
+      } else {
         response.Success = false;
         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_NULL;
@@ -255,5 +251,5 @@
 
       //if it's NOT a snapshot, NEITHER request NOR is it finished
-      if(!requested && !snapshot && job.State != State.finished) {      
+      if (!requested && !snapshot && job.State != State.finished) {
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE;
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Properties/AssemblyInfo.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Properties/AssemblyInfo.cs	(revision 4092)
@@ -55,5 +55,5 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.4078")]
-[assembly: AssemblyFileVersion("3.3.0.4078")]
-[assembly: AssemblyBuildDate("2010/07/23 09:04:35")]
+[assembly: AssemblyVersion("3.3.0.4091")]
+[assembly: AssemblyFileVersion("3.3.0.4091")]
+[assembly: AssemblyBuildDate("2010/07/23 14:14:54")]
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ServiceLocator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ServiceLocator.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ServiceLocator.cs	(revision 4092)
@@ -31,127 +31,137 @@
 using HeuristicLab.Security.Contracts.Interfaces;
 
-/// <summary>
-/// The service locator for the server core
-/// </summary>
-public class ServiceLocator {
-  private static IClientManager clientManager = null;
+namespace HeuristicLab.Hive.Server.Core {
+  /// <summary>
+  /// The service locator for the server core
+  /// </summary>
+  public class ServiceLocator {
+    private static IClientManager clientManager = null;
 
-  private static IJobManager jobManager = null;
+    private static IJobManager jobManager = null;
 
-  private static IClientCommunicator clientCommunicator = null;
+    private static IClientCommunicator clientCommunicator = null;
 
-  private static ILifecycleManager lifecycleManager = null;
+    private static ILifecycleManager lifecycleManager = null;
 
-  private static ISessionFactory sessionFactory = null;
+    private static ISessionFactory sessionFactory = null;
 
-  private static IScheduler scheduler = null;
+    private static IScheduler scheduler = null;
 
-  private static IPermissionManager permManager = null;
+    private static IPermissionManager permManager = null;
 
-  private static IHivePermissionManager hivePermManager = null;
+    private static IHivePermissionManager hivePermManager = null;
 
-  /// <summary>
-  /// Gets the client manager
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static IClientManager GetClientManager() {
-    if (clientManager == null)
-      clientManager = new ClientManager();
+    private static IContextFactory contextFactory = null;
 
-    return clientManager;
-  }
+    /// <summary>
+    /// Gets the client manager
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IClientManager GetClientManager() {
+      if (clientManager == null)
+        clientManager = new ClientManager();
 
-  /// <summary>
-  /// Gets the job manager
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static IJobManager GetJobManager() {
-    if (jobManager == null)
-      jobManager = new JobManager();
-
-    return jobManager;
-  }
-
-  /// <summary>
-  /// Gets the client Communicator
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static IClientCommunicator GetClientCommunicator() {
-    if (clientCommunicator == null)
-      clientCommunicator = new ClientCommunicator();
-
-    return clientCommunicator;
-  }
-
-  /// <summary>
-  /// Gets the lifecycle manager
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static ILifecycleManager GetLifecycleManager() {
-    if (lifecycleManager == null) {
-      lifecycleManager = new LifecycleManager();
-    }
-    return lifecycleManager;
-  }
-
-  /// <summary>
-  /// Gets the db session factory
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static ISessionFactory GetSessionFactory() {
-    if (sessionFactory == null) {
-      sessionFactory = 
-        ApplicationManager.Manager.GetInstances<ISessionFactory>().First();
-
-      sessionFactory.DbConnectionType =
-        typeof(SqlConnection);
-      
-      sessionFactory.DbConnectionString =
-        HeuristicLab.Hive.Server.Core.Properties.Settings.Default.HiveServerConnectionString;
+      return clientManager;
     }
 
-    return sessionFactory;
-  }
+    /// <summary>
+    /// Gets the job manager
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IJobManager GetJobManager() {
+      if (jobManager == null)
+        jobManager = new JobManager();
 
-  /// <summary>
-  /// Gets the scheduler
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static IScheduler GetScheduler() {
-    if (scheduler == null) {
-      scheduler = ApplicationManager.Manager.GetInstances<IScheduler>().First();
+      return jobManager;
     }
 
-    return scheduler;
-  }
+    /// <summary>
+    /// Gets the client Communicator
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IClientCommunicator GetClientCommunicator() {
+      if (clientCommunicator == null)
+        clientCommunicator = new ClientCommunicator();
 
-  /// <summary>
-  /// Gets the permission manager
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]  
-  public static IPermissionManager GetPermissionManager() {
-    if (permManager == null)
-      permManager = ApplicationManager.Manager.GetInstances<IPermissionManager>().First();
-    return permManager;
-    
-  }
+      return clientCommunicator;
+    }
 
-  /// <summary>
-  /// Gets the permission manager
-  /// </summary>
-  /// <returns></returns>
-  [MethodImpl(MethodImplOptions.Synchronized)]
-  public static IHivePermissionManager GetHivePermissionManager() {
-    if (hivePermManager == null)
-      hivePermManager = ApplicationManager.Manager.GetInstances<IHivePermissionManager>().First();
-    return hivePermManager;
+    /// <summary>
+    /// Gets the lifecycle manager
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static ILifecycleManager GetLifecycleManager() {
+      if (lifecycleManager == null) {
+        lifecycleManager = new LifecycleManager();
+      }
+      return lifecycleManager;
+    }
 
+    /// <summary>
+    /// Gets the db session factory
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static ISessionFactory GetSessionFactory() {
+      if (sessionFactory == null) {
+        sessionFactory = ApplicationManager.Manager.GetInstances<ISessionFactory>().First();
+        sessionFactory.DbConnectionType = typeof(SqlConnection);
+        sessionFactory.DbConnectionString = HeuristicLab.Hive.Server.Core.Properties.Settings.Default.HiveServerConnectionString;
+      }
+
+      return sessionFactory;
+    }
+
+    /// <summary>
+    /// Gets the scheduler
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IScheduler GetScheduler() {
+      if (scheduler == null) {
+        scheduler = ApplicationManager.Manager.GetInstances<IScheduler>().First();
+      }
+
+      return scheduler;
+    }
+
+    /// <summary>
+    /// Gets the permission manager
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IPermissionManager GetPermissionManager() {
+      if (permManager == null)
+        permManager = ApplicationManager.Manager.GetInstances<IPermissionManager>().First();
+      return permManager;
+
+    }
+
+    /// <summary>
+    /// Gets the permission manager
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IHivePermissionManager GetHivePermissionManager() {
+      if (hivePermManager == null)
+        hivePermManager = ApplicationManager.Manager.GetInstances<IHivePermissionManager>().First();
+      return hivePermManager;
+
+    }
+
+    /// <summary>
+    /// Gets the database context manager
+    /// </summary>
+    /// <returns></returns>
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public static IContextFactory GetContextFactory() {
+      if (contextFactory == null)
+        contextFactory = ApplicationManager.Manager.GetInstances<IContextFactory>().First();
+      return contextFactory;
+    }
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/DataAccessException.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/DataAccessException.cs	(revision 4092)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/DataAccessException.cs	(revision 4092)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public class DataAccessException : Exception {
+    public DataAccessException(string message) : base(message) { }
+    public DataAccessException(string message, Exception innerException) : base(message, innerException) { }
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/HeuristicLab.Hive.Server.DataAccess-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/HeuristicLab.Hive.Server.DataAccess-3.3.csproj	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/HeuristicLab.Hive.Server.DataAccess-3.3.csproj	(revision 4092)
@@ -86,8 +86,10 @@
   -->
   <ItemGroup>
+    <Compile Include="DataAccessException.cs" />
     <Compile Include="IClientConfigAdapter.cs" />
     <Compile Include="IClientConfigDao.cs" />
     <Compile Include="IClientDao.cs" />
     <Compile Include="IClientGroupDao.cs" />
+    <Compile Include="IContextFactory.cs" />
     <Compile Include="IGenericDao.cs" />
     <Compile Include="IJobDao.cs" />
@@ -132,4 +134,5 @@
     <Reference Include="System" />
     <Reference Include="System.Data" />
+    <Reference Include="System.Data.Linq" />
     <Reference Include="System.Transactions" />
     <Reference Include="System.Xml" />
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IContextFactory.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IContextFactory.cs	(revision 4092)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IContextFactory.cs	(revision 4092)
@@ -0,0 +1,27 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Data.Linq;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public interface IContextFactory {
+
+    /// <summary>
+    /// Uses transaction by default.
+    /// The caller of this Method is resposible for disposing the Context!
+    /// </summary>
+    /// <returns></returns>
+    IDisposable GetContext();
+
+    IDisposable GetContext(bool withTransaction);
+
+    DataContext CurrentContext { get; }
+
+    void RollbackTransaction();
+
+    void RemoveContext();
+
+    void RemoveAndCompleteTransaction();
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/BaseDao.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/BaseDao.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/BaseDao.cs	(revision 4092)
@@ -8,7 +8,9 @@
 namespace HeuristicLab.Hive.Server.LINQDataAccess {
   public abstract class BaseDao<TBusiness, TDatabaseEntity> {
+    private static ContextFactory contextFactory = new ContextFactory();
+
     public static HiveDataContext Context {
       get {
-        return ContextFactory.Context;
+        return contextFactory.CurrentContext as HiveDataContext;
       }
     }
@@ -17,6 +19,5 @@
       try {
         Context.SubmitChanges(ConflictMode.ContinueOnConflict);
-      } catch (ChangeConflictException e) {
-        
+      } catch (ChangeConflictException e) { 
         Logger.Warn("Concurrency Exception! " + e.Message);
         foreach (ObjectChangeConflict conflict in Context.ChangeConflicts) { 
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/ContextFactory.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/ContextFactory.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/ContextFactory.cs	(revision 4092)
@@ -3,41 +3,129 @@
 using System.Linq;
 using System.Text;
-using System.Data.Common;
-using System.Data.SqlClient;
+using HeuristicLab.Hive.Server.DataAccess;
+using System.Collections;
+using System.Data.Linq;
+using System.Transactions;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Tracing;
+using System.Threading;
+
 
 namespace HeuristicLab.Hive.Server.LINQDataAccess {
-  public class ContextFactory {
-    [ThreadStatic]
-    private static HiveDataContext _hiveDataContext = null;
+  /// <summary>
+  /// This class handles creates one Context for each Thread which asks for one.
+  /// If one Thread calls GetContext several times, it always gets the same Context object.
+  /// A context object is removed from the cache when it is disposed. 
+  /// 
+  /// Every context has a DB-Transaction over its livetime. After using the context object
+  /// it has to be disposed in order to finish the corresponding transaction.
+  /// </summary>
+  class ContextFactory : IContextFactory {
+    private static IDictionary<object, HiveDataContext> contexts = new Dictionary<object, HiveDataContext>();
+    private static IDictionary<object, TransactionScope> transactions = new Dictionary<object, TransactionScope>();
 
-    [ThreadStatic]
-    private static SqlTransaction _currentTransaction = null;
-
-    public static HiveDataContext Context { 
+    private static IContextFactory instance = null;
+    public static IContextFactory Instance {
       get {
-        if (_hiveDataContext == null) {
-          Logger.Debug("Requested new Data Context");
-          _hiveDataContext = new HiveDataContext("Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive;Integrated Security=SSPI");
-          _hiveDataContext.CommandTimeout = 240;
-        }
-        return _hiveDataContext;        
-      } 
-      set {        
-        _hiveDataContext = value;
+        if (instance == null)
+          instance = new ContextFactory();
+        return instance;
       }
     }
 
-    public static SqlTransaction CurrentTransaction { 
-      get {
-        return _currentTransaction;
-      } set {
-        _currentTransaction = value;
-      } 
+    #region IContextManager Members
+
+    public IDisposable GetContext() {
+      return GetContext(true);
     }
 
-    public static bool IsContextNull() {
-      return _hiveDataContext == null;
+    public IDisposable GetContext(bool withTransaction) {
+      Logger.Debug("opening transaction");
+      object obj = Thread.CurrentThread;
+
+      if (contexts.ContainsKey(obj)) {
+        throw new DataAccessException("Context for this Thread already defined");
+      }
+
+      Logger.Debug("creating context");
+      DisposableHiveDataContext context = CreateContext();
+      context.OnDisposing += new EventHandler(context_OnDisposing);
+      contexts.Add(obj, context);
+
+      if (withTransaction) {
+        TransactionScope transaction = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE });
+        Logger.Debug("creating  transaction");
+        
+        transactions.Add(obj, transaction);
+      }
+      return context;
     }
+
+    private static DisposableHiveDataContext CreateContext() {
+      return new DisposableHiveDataContext("Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive;Integrated Security=SSPI");
+    }
+
+    void context_OnDisposing(object sender, EventArgs e) {
+      RemoveContext();
+      RemoveAndCompleteTransaction();
+    }
+
+    public void RollbackTransaction() {
+      Logger.Debug("rolling back transaction");
+      object obj = Thread.CurrentThread;
+
+      TransactionScope transaction = transactions[obj];
+      transaction.Dispose();
+    }
+
+    public void RemoveContext() {
+      Logger.Debug("removing context");
+      object obj = Thread.CurrentThread;
+
+      contexts.Remove(obj);
+      // context gets disposed implicitly, when it is used as IDisposable
+    }
+
+    public void RemoveAndCompleteTransaction() {
+      Logger.Debug("completing transaction");
+      object obj = Thread.CurrentThread;
+
+      // context does not always have an associated transaction
+      if (transactions.ContainsKey(obj)) {
+        transactions[obj].Complete();
+        transactions[obj].Dispose();
+        transactions.Remove(obj);
+      }
+    }
+
+    public DataContext CurrentContext {
+      get {
+        object obj = Thread.CurrentThread;
+        if (contexts.ContainsKey(obj)) {
+          return contexts[obj];
+        } else {
+          return null;
+        }
+      }
+    }
+
+    #endregion
+  }
+
+  /// <summary>
+  /// Offers an event when it gets disposed
+  /// </summary>
+  class DisposableHiveDataContext : HiveDataContext {
+
+    public DisposableHiveDataContext(string connection) : base(connection) { }
+
+    protected override void Dispose(bool disposing) {
+      base.Dispose(disposing);
+      if (OnDisposing != null)
+        OnDisposing(this, new EventArgs());
+    }
+
+    public event EventHandler OnDisposing;
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj	(revision 4092)
@@ -91,4 +91,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Transactions" />
     <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq">
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/VarBinaryStream.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/VarBinaryStream.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/VarBinaryStream.cs	(revision 4092)
@@ -150,5 +150,5 @@
     dataColumn, string keyColumn, Guid key) {
       _connection = connection;
-      _transaction = (SqlTransaction) ContextFactory.Context.Transaction;
+      _transaction = (SqlTransaction) ContextFactory.Instance.CurrentContext.Transaction;
       /*
       if (_connection.State == ConnectionState.Closed) {
@@ -263,6 +263,6 @@
       if (_connection != null) {
         _connection.Close();
-        ContextFactory.Context.Dispose();
-        ContextFactory.Context = null;
+        ContextFactory.Instance.CurrentContext.Dispose();
+        ContextFactory.Instance.RemoveContext();
         Logger.Info("Connection and Context disposed and set null");
       }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/Properties/AssemblyInfo.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive/3.3/Properties/AssemblyInfo.cs	(revision 4092)
@@ -51,4 +51,4 @@
 //      Revision
 //
-[assembly: AssemblyVersion("3.3.0.4078")]
-[assembly: AssemblyFileVersion("3.3.0.4078")]
+[assembly: AssemblyVersion("3.3.0.4091")]
+[assembly: AssemblyFileVersion("3.3.0.4091")]
